﻿//Globál változók. Funkciók közti machinációkhoz.
var timeMultiplier = 1;	//Időszorzó. Default érték 1. A "Menj tovább véletlenszerű irányba!" utasítás a követő mozgás erejéig 2-re állítja. A mozgás visszaállítja 1-re.
var currentPosition = "";	//A játékos helyzetét tároló változó.

window.onload = function() {onLoad()};
window.onresize = function() {onResize()};
function onLoad() {
	fitToScreen();
	//appendRandomImages();
	updateCharSheet();
}
function onResize() {
	fitToScreen();
}
//Funkció mely képernyőre illeszti a felhasználói interface-t.
function fitToScreen() {
	var nav = document.getElementById("navigationBar");
	var leftColumn = document.getElementById("leftColumn");
	var rightColumn = document.getElementById("rightColumn");
	
	var screenWidth = window.innerWidth;
	var screenHeight = window.innerHeight;
	var colWidth = screenWidth / 2;
	var colHeight = screenHeight - 40;
	
	nav.style.width = screenWidth + "px";
	nav.style.height = "40 px";
	nav.style.top = "0px";
	nav.style.left = "0px";
	
	leftColumn.style.width = colWidth + "px";
	leftColumn.style.height = colHeight + "px";
	leftColumn.style.top = "40px";
	leftColumn.style.left = "0px";
	
	rightColumn.style.width = colWidth + "px";
	rightColumn.style.height = colHeight + "px";
	rightColumn.style.top = "40px";
	rightColumn.style.left = colWidth + "px";
}
//Funkció mely véletlenszerű képeket illeszt a fejezetpontok kb. hatodának végére.
function appendRandomImages() {
	var articles = document.getElementsByTagName("article"),
		articlesLength = articles.length,
		last, lastTag, randomImage,
		a,	// Random 0-5, hogy ad e képet. 
		b,	// Random 0-11, hogy hány képpel tol el függőlegesen.
		c,	// Random 0-1, hogy eltol e vízszintesen.
		d,	// Függőleges eltolás pixelben.
		e,	// Vízszintes eltolás pixelben.
		f = -150,	// Függőleges eltolás szorzója.
		g = -300;	// Vízszintes eltolás szorzója.
	for ( i = 0; i < articlesLength; i++ ) {
		last = articles[i].lastElementChild;
		lastTag = last.tagName;
		a = Math.floor((Math.random()*6)+0);
		if ( a == 5 && lastTag.toLowerCase() != "img" ) {
			randomImage = document.createElement("img");
				randomImage.setAttribute("src", "images/illu-random-transparent.png");
				randomImage.setAttribute("alt", "Valami fegyver");
				randomImage.setAttribute("class", "random");
			b = Math.floor((Math.random()*12)+0);
			c = Math.floor((Math.random()*2)+0);
			d = b * f;
			e = c * g;
				randomImage.style.backgroundPosition = e + "px " + d + "px";
			articles[i].appendChild(randomImage);
		}
	}
}
//Általános funkció egy 2k6 dobásra.
function roll2k6() {
	var roll1, roll2, sum;
	roll1 = Math.floor((Math.random()*6)+1);
	roll2 = Math.floor((Math.random()*6)+1);
	sum = roll1 + roll2;
	return sum;
}
//A "Menj tovább véletlenszerűen!" utasítások funkciója. Kockadobás. Hol áll a karakter? Hová menjen? 
function randomMoveOn() {
	var currentPosition = document.getElementById("charPosition").value;
	var msg = "";
	var roll;
	var targetPos;
	function rollForDirection(pos1, pos2, pos3, pos4, pos5, pos6) {
		roll = roll2k6();
		switch (roll) {
			case 2:
				targetPos = pos2;
				break;
			case 3:
				targetPos = pos1;
				break;
			case 4:
				targetPos = pos3;
				break;
			case 5:
				targetPos = pos1;
				break;
			case 6:
				targetPos = pos2;
				break;
			case 7:
				targetPos = pos6;
				break;
			case 8:
				targetPos = pos5;
				break;
			case 9:
				targetPos = pos4;
				break;
			case 10:
				targetPos = pos3;
				break;
			case 11:
				targetPos = pos5;
				break;
			case 12:
				targetPos = pos4;
				break;
		}
		if ( targetPos == "N/A" ) {
			rollForDirection();
		}
		return targetPos;
	}
	//A karakterlapon tárolt helyzet alapján meghívja a választófunkciót. Az argumentumok a lehetséges útirányok.
	switch (currentPosition) {
		case "loc03A":
			msg = "Most a 3A mezőn tartózkodsz.\n";
			rollForDirection('4A', 'N/A', 'N/A', '2A', '3B', '4B');
			break;
		case "loc09A":
			msg = "Most a 9A mezőn tartózkodsz.\n";
			rollForDirection('10A', 'N/A', 'N/A', '8A', '9B', '10B');
			break;
		case "loc02B":
			msg = "Most a 2B mezőn tartózkodsz.\n";
			rollForDirection('3B', '2A', '1A', '1B', '1C', '2C');
			break;
		case "loc02C":
			msg = "Most a 2C mezőn tartózkodsz.\n";
			rollForDirection('3C', '3B', '2B', '1C', '2D', '3D');
			break;
		case "loc05C":
			msg = "Most a 5C mezőn tartózkodsz.\n";
			rollForDirection('6C', '6B', '5B', '4C', '5D', '6D');
			break;
		case "loc06C":
			msg = "Most a 6C mezőn tartózkodsz.\n";
			rollForDirection('7C', '7B', '6B', '5C', '6D', '7D');
			break;
		case "loc11C":
			msg = "Most a 11C mezőn tartózkodsz.\n";
			rollForDirection('12C', '12B', '11B', '10C', 'N/A', 'N/A');
			break;
		case "loc05E":
			msg = "Most az 5E mezőn tartózkodsz.\n";
			rollForDirection('6E', '6D', '5D', '4E', '5F', '6F');
			break;
		case "loc08E":
			msg = "Most a 8E mezőn tartózkodsz.\n";
			rollForDirection('N/A', '8D', '7D', '7E', '8F', 'N/A');
			break;
		case "loc10E":
			msg = "Most a 10E mezőn tartózkodsz.\n";
			rollForDirection('11E', '11D', '10D', '9E', '10F', '11F');
			break;
		case "loc12E":
			msg = "Most a 12E mezőn tartózkodsz.\n";
			rollForDirection('N/A', 'N/A', '12D', '11E', '12F', 'N/A');
			break;
		case "loc05F":
			msg = "Most az 5F mezőn tartózkodsz.\n";
			rollForDirection('6F', '5E', '4E', '4F', '4G', '5G');
			break;
		case "loc07F":
			msg = "Most a 7F mezőn tartózkodsz.\n";
			rollForDirection('8F', '7E', '6E', '6F', '6G', '7G');
			break;
		case "loc12F":
			msg = "Most a 12F mezőn tartózkodsz.\n";
			rollForDirection('N/A', '1E', '11E', '11F', '11G', '12G');
			break;
		case "loc02G":
			msg = "Most a 2G mezőn tartózkodsz.\n";
			rollForDirection('3G', '3F', '2F', '1G', '2H', '3H');
			break;
		case "loc12G":
			msg = "Most a 12G mezőn tartózkodsz.\n";
			rollForDirection('N/A', 'N/A', '12F', '11G', '12H', 'N/A');
			break;
		case "loc07H":
			msg = "Most a 7H mezőn tartózkodsz.\n";
			rollForDirection('8H', '7G', '6G', '6H', 'N/A', 'N/A');
			break;
	}
	msg += "Menj tovább a " + targetPos + " mezőre!";
	alert(msg);
	timeMultiplier = 2;
}
//Szakértelem próba.
function skillCheck(skillID) {
	var skill = document.getElementById(skillID);
	var skillTotalBonus, roll, result, msg;
	if ( skill == null ) {
		msg = "A karakterlap vonatkozó mezője nem érhető el, így a szakértelempróba elvégzésére nincs lehetőség!";
	} else {
		skillTotalBonus = parseInt(skill.innerHTML);
		if ( isNaN(skillTotalBonus) == true ) {
			msg = "A karakterlap vonatkozó értéke nem szám, így a szakértelempróba elvégzésére nincs lehetőség!";
		} else {
			roll = roll2k6();
			switch (roll) {
				case 2:
					result = 2;
					msg = "A dobott szám: " + roll + "\nMódosítatlan dobás.\nA próba eredménye: " + result;
					break;
				case 12:
					result = 12;
					msg = "A dobott szám: " + roll + "\nMódosítatlan dobás.\nA próba eredménye: " + result;
					break;
				default:
					result = roll + skillTotalBonus;
					if ( result < 2 ) {
						result = 2;
					} else if (result > 12) {
						result = 12;
					} else {
						result = result;
					}
					msg = "A dobott szám: " + roll + "\nA szakértelem bónuszod: " + skillTotalBonus + "\nA próba eredménye: " + result;
					break;
			}
		}	
	}
	alert(msg);
}
//Szerencsedobás = sima 2k6 dobás bármiféle bónusz nélkül.
function luckCheck() {
	alert("A dobott szám: " + roll2k6());
}
//A karakterlapon lévő dobófunkció.
function charSheetRoll2k6() {
	document.getElementById("charRoll").innerHTML = roll2k6();
}
//A Tulajdonságok bónuszait és azok vonzatát kiszámóló funkció.
function calcAttribBonus(attribute) {
	var attributeValue, attributeBonus, attributeValueId, attributeBonusId;
	attributeValueId = "char" + attribute + "Value";
	attributeBonusId = "char" + attribute + "Bonus";
	attributeValue = document.getElementById(attributeValueId).value;
	if ( attributeValue == "2" || attributeValue == "3" || attributeValue == "4" ) {
		attributeBonus = "-1";
	} else if ( attributeValue == "5" || attributeValue == "6" || attributeValue == "7" || attributeValue == "8" ) {
		attributeBonus = "+0";
	} else if ( attributeValue == "9" || attributeValue == "10" ) {
		attributeBonus = "+1";
	} else if ( attributeValue == "11" || attributeValue == "12" ) {
		attributeBonus = "+2";
	} else {
		attributeBonus = "N/A";
	}
	document.getElementById(attributeBonusId).innerHTML = attributeBonus;
	if ( attribute == "STR" ) {
		var strength = parseInt(attributeValue);
		var endurance;
		if ( isNaN(strength) == true ) {
			endurance = 20;
		} else {
			endurance = 20 + (strength * 2);
		}
		document.getElementById("charEndurance").innerHTML = endurance;
		document.getElementById("charMeeleeOBAttribute").innerHTML = attributeBonus;
		calcSkillBonus('MeeleeOB');
	} else if ( attribute == "AGI" ) {
		document.getElementById("charRangedOBAttribute").innerHTML = attributeBonus;
		calcSkillBonus('RangedOB');
		document.getElementById("charDBAttribute").innerHTML = attributeBonus;
		calcSkillBonus('DB');
		document.getElementById("charRunningAttribute").innerHTML = attributeBonus;
		calcSkillBonus('Running');
		document.getElementById("charGeneralAttribute").innerHTML = attributeBonus;
		calcSkillBonus('General');
	} else if ( attribute == "INT" ) {
		document.getElementById("charTrickeryAttribute").innerHTML = attributeBonus;
		calcSkillBonus('Trickery');
		document.getElementById("charPerceptionAttribute").innerHTML = attributeBonus;
		calcSkillBonus('Perception');
		document.getElementById("charMagicalAttribute").innerHTML = attributeBonus;
		calcSkillBonus('Magical');
	} else {
		alert("Valami baj van! :D");
	}
}
//Szakértelmek összes bónuszát kiszámoló funkció.
function calcSkillBonus(skill) {
	var skillLevelId = "char" + skill + "Levels";
	var skillAttribId = "char" + skill + "Attribute";
	var skillSpecialId = "char" + skill + "Special";
	var skillTotalId = "char" + skill + "Total";
	var skillLevel;
	var skillAttribBonus;
	var skillSpecialBonus;
	var skillTotalBonus;
	//Szint bónusz
	if ( skill == "DB" || skill == "Running" || isNaN(document.getElementById(skillLevelId).value) == true || document.getElementById(skillLevelId).value == "") {
		skillLevel = 0;
	} else {
		skillLevel = parseInt(document.getElementById(skillLevelId).value);
	}
	//Tulajdonság bónusz
	if ( document.getElementById(skillAttribId).innerHTML == "N/A" ) {
		skillAttribBonus = 0;
	} else {
		skillAttribBonus = parseInt(document.getElementById(skillAttribId).innerHTML);
	}
	//Különleges bónusz
	if ( isNaN(document.getElementById(skillSpecialId).value) == true || document.getElementById(skillSpecialId).value == "") {
		skillSpecialBonus = 0;
	} else {
		skillSpecialBonus = parseInt(document.getElementById(skillSpecialId).value);
	}
	skillTotalBonus = skillLevel + skillAttribBonus + skillSpecialBonus;
	document.getElementById(skillTotalId).innerHTML = skillTotalBonus;
}
//A karakterlap lementése sütibe.
function charSave(saveSlot) {
	var data = document.getElementsByTagName("input");
	var notes = document.getElementById("charNotes");
	var dataId, dataValue;
	var inputTexts = "";	//Szöveg alapu input elemeket tartalmazza.
	var inputCheckboxes = "";	//Checkboxok állapotát tartalmazza.
	var inputs = "";
	//Az input elemekből string-et csinál:
	for ( i=0; i<data.length; i++ ) {
		if (data[i].getAttribute("type") == "checkbox") {
			dataId = data[i].getAttribute("id");
			dataValue = data[i].checked;
			inputCheckboxes +=  dataId + "#" + dataValue + "&";
		} else {
			dataId = data[i].getAttribute("id");
			dataValue = data[i].value;
			inputTexts += dataId + "#" + dataValue + "&";
		}
	}
	//A textarea tartalmát hozzáadja a string-hez:
	dataId = notes.getAttribute("id");
	dataValue = notes.value;
	inputTexts += dataId + "#" + dataValue + "&";
	//Összeilleszti a két stringet.
	inputs = inputTexts + inputCheckboxes;
	//Sütibe rakja az inputokból csinált stringet.
	document.cookie = saveSlot + "=" + inputs + ";max-age=2592000" ;
	alert("A karakterlap adatai elmentve.");
}
//A karakterlap betöltése sütiből, illetve a mintakarakter adatainak betöltése.
function charLoad(saveSlot) {
	var charCookie, start, end, inputString, inputs, data;
	if ( saveSlot == "default" ) {
		inputString = "charName#Rána&charSTRValue#8&charAGIValue#4&charINTValue#12&charMeeleeOBLevels#1&charRangedOBLevels#-2&charGeneralLevels#1&charTrickeryLevels#1&charPerceptionLevels#1&charMagicalLevels#2&";
	} else if ( saveSlot == "slot1" ) {
		charCookie = document.cookie;
		start = 0;
		end = charCookie.indexOf("slot2") -2;
		inputString = (charCookie.slice(start, end)).slice(6);
	} else if ( saveSlot == "slot2" ) {
		charCookie = document.cookie;
		start = charCookie.indexOf("slot2");
		end = charCookie.indexOf("slot3") -2;
		inputString = (charCookie.slice(start, end)).slice(6);
	} else /*azaz saveSlot == "slot3"*/ {
		charCookie = document.cookie;
		start = charCookie.indexOf("slot3");
		end = charCookie.length;
		inputString = (charCookie.slice(start, end)).slice(6);
	}
	inputs = inputString.split("&");
	for ( i=0; i<inputs.length; i++ ) {
		data = inputs[i].split("#");
		if ( data[0].slice(9) == "Check" && data[1] == "true" ) {
			document.getElementById(data[0]).checked = true;
		} else if ( data[0].slice(9) == "Check" && data[1] == "false" ) {
			document.getElementById(data[0]).checked = false;
		} else if ( data[0] == "" ) {
			continue;
		} else {
			document.getElementById(data[0]).value = data[1];
		}
	}
	updateCharSheet();
	var currentPosition = document.getElementById("charPosition").value;
	var mapLink = "mapLink" + currentPosition;
	document.getElementById(mapLink).style.border = "1px solid #f00";
	alert("A karakterlap adatai betöltve.");
}
//A karakterlap adatait kitörlő funkció.
function charClear() {
	var data = document.getElementsByTagName("input");
	for ( i=0; i<data.length; i++ ) {
		if (data[i].getAttribute("type") == "checkbox") {
			data[i].checked = false;
		} else {
			data[i].value = "";
		}
	}
	document.getElementById("charNotes").value = "";
	var mapInt = document.getElementById("mapInt");
	var mapIntLinks = mapInt.getElementsByTagName("a");
	for ( i=0; i<mapIntLinks.length; i++ ) {
		mapIntLinks[i].style.border = "0px none";
	}
	var mapExt = document.getElementById("mapExt");
	var mapExtLinks = mapExt.getElementsByTagName("a");
	for ( i=0; i<mapExtLinks.length; i++ ) {
		mapExtLinks[i].style.border = "0px none";
	}
	updateCharSheet();
	alert("A karakterlap adatai törölve.");
}
//A harcot levezető funkció.
//Az argumentumok:
//enemyName, enemyOB, enemyDB, enemyEnd = Az ellenfél jellemzői. Sorban a neve, a Támadás bónusza, a Védekezés bónusza és az Állóképessége.
//charSurprised = Ha "true" akkor a játékos meglepett  és fordul a támadások sorendje, ha "false" akkor nem.
//charCanFlee = Ha "true" akkor a játékos elmenekülhet a harcból, ha "false" akkor nem.
function combat(enemyName, enemyOB, enemyDB, enemyEnd, charSurprised, charCanFlee) {
	var playerOB = parseInt(document.getElementById("charMeeleeOBTotal").innerHTML);	//A játékos Támadás bónusza.
	var playerDB = parseInt(document.getElementById("charDBTotal").innerHTML);	//A játékos Védekezés bónusza.
	var playerEnd = parseInt(document.getElementById("charEndurance").innerHTML);	//A játékos Állóképesség értéke.
	var playerDamTaken = parseInt(document.getElementById("charDamageTaken").value);	//A játékos Elszenvedett sérülés értéke, a karakterlapon szereplő értékről indul, ha eléri az Állóképességét elájul.
	var roll;	//Kockadobás eredménye.
	var enemyDamTaken = 0;	//Az ellenfél Elszenvedett sérülés értéke. 0-ról indul, találatok módosítják, ha eléri az Állóképességét elájul.
	var roundCounter = 0;	//Harci kör számláló.
	var firstAttack = "player";	//Ki támad először? Ha a játékos akkor "player" (default), ha az ellenfél akkor "enemy".
	var msg = "";	//A harci kör eredményét tartalmazó szöveg. Alert vagy confirm box ezt dobja föl minden kör végén.
	var combatRatio;	//A támadó TB-je mínusz a védekező VB-je.
	var attackResult;	//A támadás eredménye: szám = az okozott sebzés, E = eszméletvesztés, H = halál.
	var charRuns;	//"true" ha egy harci körben a játékosnak sikerül elmenekülnie, egyébként "false".
	
	//Ha a játékos meglepett, átállítja a támadások sorrendjét.
	if ( charSurprised == "true" ) {
		firstAttack = "enemy";
	}
	//A menekülési próbát dobó funkció.
	function fleeFromCombat() {
		var runningBonus = parseInt(document.getElementById("charRunningTotal").innerHTML);
		var runningResult;
		roll = roll2k6();
		switch (roll) {
			case 2:
				runningResult = 2;
				break;
			case 12:
				runningResult = 12;
				break;
			default:
				runningResult = roll + runningBonus;
				if ( runningResult < 2 ) {
					runningResult = 2;
				} else if (runningResult > 12) {
					runningResult = 12;
				} else {
					runningResult = runningResult;
				}
		}
		//Ha a próba eredménye 9 vagy nagyobb, a játékosnak sikerül elmenekülnie.
		if ( runningResult > 8 ) {
			charRuns = "true";
		} else {
			charRuns = "false";
		}
		return charRuns;
	}
	//Egy támadást lejátszó funkció.
	function attack(combatant) {
		//Megnézi, hogy ki támad, ez alapján számol TB-VB értéket.
		if ( combatant == "player" ) {
			combatRatio = playerOB - parseInt(enemyDB);
		} else /* ( combatant == "enemy" ) */ {
			combatRatio = parseInt(enemyOB) - playerDB;
		}
		roll = roll2k6();
		//A TB-VB érték nem lehet kisebb -4-nél, a +5 fölötti többletet pedig a dobás értékéhez kell adni.
		if ( combatRatio < -4 ) {
			combatRatio = -4;
		} else if ( combatRatio > 5 ) {
			roll = roll + combatRatio -5;
			combatRatio = 5;
		} else {
			combatRatio = combatRatio;
		}
		//A dobás értéke nem lehet nagyobb 12-nél.
		if ( roll > 12 ) {
			roll = 12;
		} else {
			roll = roll;
		}
		//combatTable array mátrix.
		var combatTableRow2 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
		var combatTableRow3 = [0, 0, 0, 0, 0, 0, 1, 1, 1, 2];
		var combatTableRow4 = [0, 0, 0, 0, 0, 1, 2, 2, 3, 4];
		var combatTableRow5 = [0, 0, 0, 0, 1, 2, 3, 4, 5, 6];
		var combatTableRow6 = [0, 0, 0, 1, 2, 3, 4, 5, 6, 7];
		var combatTableRow7 = [0, 1, 1, 2, 3, 4, 5, 6, 7, 8];
		var combatTableRow8 = [1, 2, 2, 3, 4, 5, 6, 7, 8, 9];
		var combatTableRow9 = [2, 2, 3, 4, 5, 6, 7, 8, 9, "E"];
		var combatTableRow10 = [3, 4, 5, 6, 7, 7, 8, "E", "E", "E"];
		var combatTableRow11 = [5, 6, 7, 8, "E", "E", "E", "E", "H", "H"];
		var combatTableRow12 = ["E", "E", "E", "E", "H", "H", "H", "H", "H", "H"];
		var combatTable = [combatTableRow2, combatTableRow3, combatTableRow4, combatTableRow5, combatTableRow6, combatTableRow7, combatTableRow8, combatTableRow9, combatTableRow10, combatTableRow11, combatTableRow12];
		//A támadás eredményének meghatározása a combatTable array mátrixból.
		var rollIndex = roll - 2;
		var combatRatioIndex = combatRatio + 4;
		attackResult = combatTable[rollIndex][combatRatioIndex];
		return attackResult;
	}
	//A játékos támadását levezető funkció.
	function playerAttack() {
		attack('player');
		msg += "\nTámadsz és ";
		if ( attackResult == "H" ) {
			msg += "halálos csapást mérsz ellenfeledre.\n";
		} else if ( attackResult == "E" ) {
			msg += "ellenfeled csapásod nyomán elveszíti az eszméletét.\n";
		} else {
			enemyDamTaken = enemyDamTaken + attackResult;
			msg += attackResult + " pont sebzést okozol ellenfelednek.\nEllenfeled Elszenvedett Sérülés értéke: " + enemyDamTaken + ".\n";
		}
		return attackResult;
		return enemyDamTaken;
	}
	//Az ellenfél támadását levezető funkció.
	function enemyAttack() {
		attack('enemy');
		msg += "\nEllenfeled megtámad és ";
		if ( attackResult == "H" ) {
			msg += "halálos erejű csapásával megöl téged.\n";
		} else if ( attackResult == "E" ) {
			msg += "csapásától elveszíted az eszméleted.\n";
		} else {
			playerDamTaken = playerDamTaken + attackResult;
			document.getElementById("charDamageTaken").value = playerDamTaken;
			msg += attackResult + " pont sebzést okoz neked.\nElszenvedett Sérülés értéked: " + playerDamTaken + ".\n";
		}
		return attackResult;
		return playerDamTaken;
	}
	function combatRound(playerFleeing) {
		roundCounter++;
		msg = "";
		if ( isNaN(playerDamTaken) == true || playerDamTaken < 0 ) {
			alert("A karakterlap Elszenvedett Sérülés rubrikájában hibás érték szerepel, így a harc nem futhat le!\nAz érték 0 vagy pozitív egész szám lehet.");
		} else {
			msg += "Ellenfeled: " + enemyName + "\n";
			msg += roundCounter + ". harci kör\n";
			//Ha a játékos támad először.
			if ( firstAttack == "player" ) {
				playerAttack();
				//Ha legyőzi az ellenfelet.
				if ( attackResult == "H" || attackResult == "E" || enemyDamTaken > enemyEnd ) {
					msg += "\nLegyőzted ellenfeledet!";
					alert(msg);
				//Egyébként az ellenfél is üt.
				} else {
					enemyAttack();
					//Ha az ellenfél győzi le a játékost.
					if ( attackResult == "H" || attackResult == "E" || playerDamTaken > playerEnd ) {
						msg += "\nEllenfeled legyőzött téged!";
						alert(msg);
					//Egyébként új harci kör kezdődik.
					} else {
						if ( charCanFlee == "true" ) {
							msg += "\nVálassz az alábbi lehetőségek közül!\n\tOK = folytatod a harcot.\n\tMégse = megpróbálsz elmenekülni.";
							var choice = confirm(msg);
							if ( choice == true ) {
								combatRound();
							} else {
								firstAttack = "enemy";
								combatRound('true');
							}
						} else {
							alert(msg);
							combatRound();
						}
					}
				}
			//Ha az ellenfél támad először.
			} else /* firstAttack == "enemy" */ {
				enemyAttack();
				//Ha az ellenfél legyőzi a játékost.
				if ( attackResult == "H" || attackResult == "E" || playerDamTaken > playerEnd ) {
					msg += "\nEllenfeled legyőzött téged!";
					alert(msg);
				//Egyébként a játékos jön.
				//Ha menekül.
				} else if ( playerFleeing == "true" ) {
					fleeFromCombat();
					//Ha sikerül a Futás próba.
					if ( charRuns == "true" ) {
						msg += "\nSikerül elmenekülnöd a harcból.";
						alert(msg);
					//Ha nem.
					} else {
						msg += "\nNem sikerül kibontakoznod, folytatnod kell a harcot.\n";
						msg += "\nVálassz az alábbi lehetőségek közül!\n\tOK = folytatod a harcot.\n\tMégse = megpróbálsz elmenekülni.";
						var choice = confirm(msg);
						if ( choice == true ) {
							firstAttack = "player";
							combatRound();
						} else {
							firstAttack = "enemy";
							combatRound('true');
						}
					}
				//Ha támad.
				} else {
					playerAttack();
					//Ha a játékos legyőzi az ellenfelet.
					if ( attackResult == "H" || attackResult == "E" || enemyDamTaken > enemyEnd ) {
						msg += "\nLegyőzted ellenfeledet!";
						alert(msg);
					//Egyébként új harci kör kezdődik.
					} else {
						if ( charCanFlee == "true" ) {
							msg += "\nVálassz az alábbi lehetőségek közül!\n\tOK = folytatod a harcot.\n\tMégse = megpróbálsz elmenekülni.";
							var choice = confirm(msg);
							if ( choice == true ) {
								firstAttack = "player";
								combatRound();
							} else {
								firstAttack = "enemy";
								combatRound('true');
							}
						} else {
							alert(msg);
							combatRound();
						}
					}
				}
			}
		}
	}
	combatRound();
}
//A szövegben található Elszenvedett Sérülésre vonatkozó módosítófunkció.
function updateDamTaken(data) {
	if ( data == "endurance" ) {
		document.getElementById("charDamageTaken").value = document.getElementById("charEndurance").innerHTML;
		alert("A változás felvezetve a karakterlapra.");
	} else {
		var newDamTaken = parseInt(document.getElementById("charDamageTaken").value) + parseInt(data);
		alert("A változás felvezetve a karakterlapra.");
		if ( newDamTaken < 0 ) {
			document.getElementById("charDamageTaken").value = 0;
		} else if ( newDamTaken > parseInt(document.getElementById("charEndurance").innerHTML)) {
			document.getElementById("charDamageTaken").value = newDamTaken;
			alert("Sérüléseidből kifolyólag elveszíted az eszméletedet.\nKalandod itt véget ért!");
		} else {
			document.getElementById("charDamageTaken").value = newDamTaken;
		}
	}
}
//A karakter helyzetét kezelő funkció.
function setCurrentPosition(newPos) {
	currentPosition = newPos;
	document.getElementById("charPosition").value = currentPosition;
	var mapInt = document.getElementById("mapInt");
	var mapIntLinks = mapInt.getElementsByTagName("a");
	for ( i=0; i<mapIntLinks.length; i++ ) {
		mapIntLinks[i].style.border = "0px none";
	}
	var mapExt = document.getElementById("mapExt");
	var mapExtLinks = mapExt.getElementsByTagName("a");
	for ( i=0; i<mapExtLinks.length; i++ ) {
		mapExtLinks[i].style.border = "0px none";
	}
	var mapLink = "mapLink" + newPos;
	document.getElementById(mapLink).style.border = "1px solid #f00";
}
//A megszerzett nyomot a karakterlapra felvezető funkció.
function addClue(clueID) {
	document.getElementById(clueID).checked = true;
}
//Funkció, ami a Tulajdonság Bónuszokat számító funkciók meghívása által frissíti a karakterlapot. Plusz böngészőablak frissítés esetén megtartja a tartózkodási hely jelölését.
function updateCharSheet() {
	calcAttribBonus('STR');
	calcAttribBonus('AGI');
	calcAttribBonus('INT');
	var currentPosition = document.getElementById("charPosition").value;
	if ( currentPosition != "" ) {
		var mapLink = "mapLink" + currentPosition;
		document.getElementById(mapLink).style.border = "1px solid #f00";
	}
}
//Az itőt frissítő funkció.
function addTime(time, type) {
	var minutes = parseInt(document.getElementById("charTimeMinutes").value);
	var days = document.getElementById("charTimeDays").value;
	var sprainedAnkle = document.getElementById("charSprainedAnkle").checked;
	var sprainedAnkleMultiplier = 1;	//Default eset, a játékos egészséges. Ha a 302. fp.-n kimegy a bokája, akkor "2".
	if ( sprainedAnkle == true ) {
		sprainedAnkleMultiplier = 2;
	}
	//Ha az input üres, nem szám szerepel benne vagy negatív, akkor beállítja 0-nak.
	if ( isNaN(minutes) == true ) {
		minutes = 0;
	} else if ( minutes < 0 ) {
		minutes = 0;
	} else {
		minutes = parseInt(minutes);
	}
	if ( isNaN(days) == true ) {
		days = 0;
	} else if ( days < 0 ) {
		days = 0;
	} else {
		days = parseInt(days);
	}
	//Kivételes esetek:
	if ( time == "enc320" ) {
		document.getElementById("charTimeDays").value = 10;
		document.getElementById("charTimeMinutes").value = 0;
	} else if ( time == "enc240" ) {
		document.getElementById("charTimeMinutes").value = "720";
	//Default eset: az idő szám.
	} else {
		//Ha mozgás, akkor számítanak a szorzók: véletlen irány, kiment boka.
		if ( type == "movement" ) {
			document.getElementById("charTimeMinutes").value = minutes + ( parseInt(time) * timeMultiplier * sprainedAnkleMultiplier);
		//Egyébként esemény és nem.
		} else {
			document.getElementById("charTimeMinutes").value = minutes + parseInt(time);
		}
	}
	timeMultiplier = 1;
}
//A pihenés funkciója.
function rest() {
	var minutes = parseInt(document.getElementById("charTimeMinutes").value);
	var charDamTaken = parseInt(document.getElementById("charDamageTaken").value);
	if ( isNaN(minutes) == true || isNaN(charDamTaken) == true ) {
		alert("A karakterlap nincs megfelelően kitöltve, így a feladat nem végezhető el.");
	} else if ( charDamTaken <= 0 ) {
		document.getElementById("charTimeMinutes").value = minutes +20;
		document.getElementById("charDamageTaken").value = charDamTaken;
		alert("Pihentél 20 percet.");
	} else {
		document.getElementById("charTimeMinutes").value = minutes +20;
		document.getElementById("charDamageTaken").value = charDamTaken -1;
		alert("Pihentél 20 percet, ezért Elszenvedett Sérülésed csökken 1 ponttal.");
	}
}
//302. fejezetpont: a játékosnak kificamodik a bokája, amitől minden mozgás ideje megduplázódik.
function sprainingAnkle() {
	document.getElementById("charSprainedAnkle").checked = true;
}